/**
 *  @file
 *  @copyright defined in eos/LICENSE.txt
 */
#pragma once

#include <eosio/chain/types.hpp>
#include <eosio/chain/contract_types.hpp>

namespace eosio { namespace chain {

   class apply_context;

   /**
    * @defgroup native_action_handlers Native Action Handlers
    */
   ///@{
   void apply_eosio_newaccount(apply_context&);
   void apply_eosio_updateauth(apply_context&);
   void apply_eosio_deleteauth(apply_context&);
   void apply_eosio_linkauth(apply_context&);
   void apply_eosio_unlinkauth(apply_context&);

   /*
   void apply_eosio_postrecovery(apply_context&);
   void apply_eosio_passrecovery(apply_context&);
   void apply_eosio_vetorecovery(apply_context&);
   */

   void apply_eosio_setcode(apply_context&);
   void apply_eosio_setabi(apply_context&);
   void apply_eosio_setconfig(apply_context&);

   void apply_eosio_lockcode(apply_context&);
   void apply_eosio_unlockcode(apply_context&);

   void apply_eosio_canceldelay(apply_context&);

   void apply_eosio_activatevm(apply_context& context);
   ///@}  end action handlers

} } /// namespace eosio::chain
